## grafx2 2.6

=== Makefile ===
ifdef WIN32CROSS
OPT = WIN32CROSS=1 \

endif

.PHONY:	all tools grafx2 ziprelease 3rdparty win32installer \
        doc doxygen docarchive doxygenarchive htmldoc

all:	grafx2 tools

doc:	doxygen

docarchive:	doxygenarchive

grafx2:
	$(OPT)$(MAKE) -C src/

ziprelease: grafx2
	$(OPT)$(MAKE) -C src/ ziprelease

tools:	src/version.c
	$(MAKE) -C tools/

3rdparty:
	cd 3rdparty/ && $(OPT)$(MAKE)

win32installer:
	$(MAKE) -C install/

# generate Doxygen to doc/doxygen
doxygen:
	$(MAKE) -C tools/ doxygen

doxygenarchive:
	$(MAKE) -C tools/ doxygenarchive

# generate HTML doc to doc/html
htmldoc:
	$(MAKE) -C src/ htmldoc

# this C file is generated by the build
src/version.c:	grafx2

=== 3rdparty/Makefile ===
SDLDEVEL = SDL-devel-1.2.15-mingw32.tar.gz
SDLDEVELURL = https://www.libsdl.org/release/$(SDLDEVEL)
SDLDEVELPATCH = SDL-1.2.15.patch
SDLIMAGE = SDL_image-1.2.12
SDLIMAGEARCH = SDL_image-1.2.12.tar.gz
SDLIMAGEURL = https://www.libsdl.org/projects/SDL_image/release/$(SDLIMAGEARCH)
SDLIMAGEPATCHES = SDL_image-1.2.12.XCF_infinite_loop.patch \
                  SDL_image-1.2.12.XCF_v11_64bits_offsets.patch \
                  SDL_image_XCF_v11_load_level.patch
SDLTTF=SDL_ttf-2.0.11
SDLTTFARCH=$(SDLTTF).tar.gz
SDLTTFURL=https://www.libsdl.org/projects/SDL_ttf/release/$(SDLTTFARCH)
LIBPNG = libpng-1.6.35
LIBPNGARCH = $(LIBPNG).tar.gz
LIBPNGURL = https://download.sourceforge.net/libpng/$(LIBPNGARCH)
LIBPNGURLALT = ftp://ftp-osl.osuosl.org/pub/libpng/src/libpng16/$(LIBPNGARCH)
JPEGVER = 9c
JPEGDIR = jpeg-$(JPEGVER)
JPEGARCH = jpegsrc.v$(JPEGVER).tar.gz
JPEGURL = http://www.ijg.org/files/$(JPEGARCH)
# http://www.simplesystems.org/libtiff/
# https://gitlab.com/libtiff/libtiff
LIBTIFF = tiff-4.0.10
LIBTIFFARCH = $(LIBTIFF).tar.gz
LIBTIFFURL = https://download.osgeo.org/libtiff/$(LIBTIFFARCH)
LIBTIFFURLALT = https://fossies.org/linux/misc/$(LIBTIFFARCH)
ZLIB=zlib-1.2.11
ZLIBARCH=$(ZLIB).tar.gz
ZLIBURL=https://www.zlib.net/$(ZLIBARCH)
FREETYPE=freetype-2.9.1
FREETYPEARCH=$(FREETYPE).tar.gz
FREETYPEURL=https://download.savannah.gnu.org/releases/freetype/$(FREETYPEARCH)
LUAVER=5.3.5
LUA=lua-$(LUAVER)
LUAARCH=$(LUA).tar.gz
LUAURL=https://www.lua.org/ftp/$(LUAARCH)
# https://storage.googleapis.com/downloads.webmproject.org/releases/webp/libwebp-0.6.1.tar.gz
RECOILVER=4.3.1
RECOIL=recoil-$(RECOILVER)
RECOILARCH=$(RECOIL).tar.gz
# https://downloads.sourceforge.net/project/recoil/recoil/4.3.0/recoil-4.3.0.tar.gz
RECOILURL=https://downloads.sourceforge.net/project/recoil/recoil/$(RECOILVER)/$(RECOILARCH)
RECOILURLALT=http://nanard.free.fr/grafx2/$(RECOILARCH)

PREFIX = $(PWD)/usr

MKDIR = mkdir -p
CP = cp -v
TAR = $(shell which tar)
GETURL = $(shell WGET=`which wget` ; if [ "$?" = "0" ] && [ -x "$WGET" ] ; then echo "$WGET" ; else echo "curl -O -L --max-time 120" ; fi )

BUILD_CC := $(CC)
STRIP = strip

# There is no uname under windows, but we can guess we are there with the COMSPEC env.var
# Windows specific
ifdef COMSPEC
WIN32 = 1
endif

ifdef WIN32CROSS
WIN32 = 1
CROSS_CC ?= $(shell which i686-w64-mingw32-gcc || which mingw32-gcc)
CROSS_AR ?= $(shell which i686-w64-mingw32-ar || which mingw32-ar)
CROSS_RANLIB ?= $(shell which i686-w64-mingw32-ranlib || which mingw32-ranlib)
CROSS_STRIP ?= $(shell which i686-w64-mingw32-strip || which mingw32-strip)
CROSS_LDFLAGS += -static-libgcc
CC = $(CROSS_CC)
AR = $(CROSS_AR)
RANLIB = $(CROSS_RANLIB)
STRIP = $(CROSS_STRIP)
CFLAGS = $(CROSS_CFLAGS)
LDFLAGS = $(CROSS_LDFLAGS)
endif

HOST = $(shell $(CC) -dumpmachine)
#HOST = i686-pc-mingw32
DATE = $(shell date -R)

.PHONY:	all clean clean_archives clean_all libs libpng libsdl libsdl_image libsdl_ttf libjpeg libtiff zlib freetype lua recoil

all:	libs

clean_all:	clean clean_archives

clean:
	$(RM) -r usr/ $(LIBPNG) $(ZLIB) $(SDLIMAGE) $(JPEGDIR) $(LIBTIFF)
	$(RM) -r $(SDLTTF) $(FREETYPE) SDL-1.2.15 $(LUA) $(RECOIL)

clean_archives:
	$(RM) -r archives

libs:	libpng libsdl libsdl_image libsdl_ttf lua
libsdl:	$(PREFIX)/lib/libSDLmain.a
libsdl_image:	$(PREFIX)/lib/libSDL_image.a
libsdl_ttf:	$(PREFIX)/lib/libSDL_ttf.a
libjpeg:	$(PREFIX)/lib/libjpeg.a
libpng:	$(PREFIX)/lib/libpng.a
libtiff:	$(PREFIX)/lib/libtiff.a
zlib:	$(PREFIX)/lib/libz.a
freetype:	$(PREFIX)/lib/libfreetype.a
lua:	$(PREFIX)/lib/liblua.a

$(PREFIX)/lib/liblua.a:	$(LUA)/.ok
ifdef WIN32
	cd $(LUA) && $(MAKE) PLAT=mingw CC=$(CC) RANLIB=$(RANLIB)
	cd $(LUA) && $(MAKE) install PLAT=mingw INSTALL_TOP=$(PREFIX) TO_BIN="lua.exe luac.exe"
	$(MKDIR) ../bin && for f in $(LUA)/src/lua*.dll ; do \
	    $(CP) $$f ../bin ; \
	    $(STRIP) ../bin/`basename $$f` ; \
	  done
	echo "The Windows distribution of Grafx2 is linked with Lua v$(LUAVER)" > ../doc/README-lua.txt
	grep LUA_COPYRIGHT $(LUA)/src/lua.h | cut -d'"' -f 2 >> ../doc/README-lua.txt

	echo "" >> ../doc/README-lua.txt
	echo "License : http://www.lua.org/license.html" >> ../doc/README-lua.txt
	# extract license from readme.html
	awk '/BLOCKQUOTE/{flag=1-flag;next}flag' $(LUA)/doc/readme.html | grep -v '<P>' | tail --lines +2 >> ../doc/README-lua.txt
endif

$(LUA)/.ok:	archives/$(LUAARCH)
	$(TAR) xzf $<
	touch $@

$(PREFIX)/lib/libSDLmain.a:	archives/$(SDLDEVEL)
	$(TAR) xzf $<
	patch -p0 < $(SDLDEVELPATCH)
	$(MKDIR) $(PREFIX)
	cd SDL-1.2.15 && CROSS_PATH=$(PREFIX) $(MAKE) cross
ifdef WIN32
	$(MKDIR) ../bin && $(CP) $(PREFIX)/bin/SDL.dll ../bin && $(STRIP) ../bin/SDL.dll
	echo "The following file:" > ../doc/README-SDL.txt
	echo "" >> ../doc/README-SDL.txt
	echo "	SDL.dll" >> ../doc/README-SDL.txt
	echo "" >> ../doc/README-SDL.txt
	echo "is the runtime environment for the SDL library." >> ../doc/README-SDL.txt
	tail --lines +3 SDL-1.2.15/README-SDL.txt >> ../doc/README-SDL.txt
endif

$(PREFIX)/lib/libSDL_image.a:	$(PREFIX)/lib/libjpeg.a
$(PREFIX)/lib/libSDL_image.a:	$(PREFIX)/lib/libtiff.a
$(PREFIX)/lib/libSDL_image.a:	$(PREFIX)/lib/libpng.a

$(PREFIX)/lib/libSDL_image.a:	$(SDLIMAGE)/.ok
	cd $(SDLIMAGE) && CC="$(CC) $(LDFLAGS)" CPPFLAGS=-I$(PREFIX)/include LDFLAGS="-L$(PREFIX)/lib" LIBPNG_CFLAGS= LIBPNG_LIBS=-lpng ./configure --prefix=$(PREFIX) --with-sdl-prefix=$(PREFIX) --host=$(HOST) --disable-webp
	cd $(SDLIMAGE) && $(MAKE)
	cd $(SDLIMAGE) && $(MAKE) install
ifdef WIN32
	$(MKDIR) ../bin && $(CP) $(PREFIX)/bin/SDL_image.dll ../bin && $(STRIP) ../bin/SDL_image.dll
	echo "$(SDLIMAGE)" > ../doc/README-SDL_image.txt
	echo "" >> ../doc/README-SDL_image.txt
	echo "dependencies :" >> ../doc/README-SDL_image.txt
	echo " - $(LIBPNG)" >> ../doc/README-SDL_image.txt
	echo " - http://www.ijg.org/ JPEG lib $(JPEGVER)" >> ../doc/README-SDL_image.txt
	echo " - $(LIBTIFF)" >> ../doc/README-SDL_image.txt
	echo "" >> ../doc/README-SDL_image.txt
	echo "License :" >> ../doc/README-SDL_image.txt
	cat $(SDLIMAGE)/COPYING >> ../doc/README-SDL_image.txt
endif

$(SDLIMAGE)/.ok:	archives/$(SDLIMAGEARCH)
	$(TAR) xzf $<
	cd $(SDLIMAGE) ; for p in $(SDLIMAGEPATCHES) ; do echo "applying $$p" ; patch -p1 < ../$$p ; done
	touch $@

$(PREFIX)/lib/libSDL_ttf.a:	$(PREFIX)/lib/libfreetype.a

$(PREFIX)/lib/libSDL_ttf.a:	$(SDLTTF)/.ok
	cd $(SDLTTF) && PKG_CONFIG_PATH=$(PREFIX)/lib/pkgconfig \
	  CC=$(CC) CPPFLAGS=-I$(PREFIX)/include LDFLAGS="-L$(PREFIX)/lib $(LDFLAGS)" \
	  ./configure --prefix=$(PREFIX) --with-sdl-prefix=$(PREFIX) --with-freetype-prefix=$(PREFIX) --host=$(HOST)
	cd $(SDLTTF) && $(MAKE)
	cd $(SDLTTF) && $(MAKE) install
ifdef WIN32
	$(MKDIR) ../bin && $(CP) $(PREFIX)/bin/SDL_ttf.dll ../bin && $(STRIP) ../bin/SDL_ttf.dll
	echo "$(SDLTTF)" > ../doc/README-SDL_ttf.txt
	echo "" >> ../doc/README-SDL_ttf.txt
	echo "dependencies :" >> ../doc/README-SDL_ttf.txt
	echo " - $(FREETYPE)" >> ../doc/README-SDL_ttf.txt
	echo "" >> ../doc/README-SDL_ttf.txt
	echo "License :" >> ../doc/README-SDL_ttf.txt
	cat $(SDLTTF)/COPYING >> ../doc/README-SDL_ttf.txt
endif

$(SDLTTF)/.ok:	archives/$(SDLTTFARCH)
	$(TAR) xzf $<
	touch $@

$(PREFIX)/lib/libfreetype.a:	$(PREFIX)/lib/libpng.a

$(PREFIX)/lib/libfreetype.a:	$(FREETYPE)/.ok
	cd $(FREETYPE) && ./configure --build=$(shell $(BUILD_CC) -dumpmachine) --host=$(HOST) \
	  --prefix=$(PREFIX) --enable-freetype-config \
	  PKG_CONFIG_LIBDIR=$(PREFIX)/lib/pkgconfig LDFLAGS="$(LDFLAGS)"
	cd $(FREETYPE) && $(MAKE)
	cd $(FREETYPE) && $(MAKE) install
ifdef WIN32
	$(MKDIR) ../bin && for f in $(PREFIX)/bin/libfreetype*.dll ; do \
	    $(CP) $$f ../bin ; \
	    $(STRIP) ../bin/`basename $$f` ; \
	  done
	echo "$(FREETYPE)" > ../doc/README-freetype.txt
	echo "" >> ../doc/README-freetype.txt
	echo "License :" >> ../doc/README-freetype.txt
	echo "" >> ../doc/README-freetype.txt
	cat $(FREETYPE)/docs/GPLv2.TXT >> ../doc/README-freetype.txt
endif

$(FREETYPE)/.ok:	archives/$(FREETYPEARCH)
	$(TAR) xzf $<
	touch $@

$(PREFIX)/lib/libjpeg.a:	$(JPEGDIR)/.ok
	cd $(JPEGDIR) && CC=$(CC) ./configure --prefix=$(PREFIX) --host=$(HOST)
	cd $(JPEGDIR) && $(MAKE)
	cd $(JPEGDIR) && $(MAKE) install
ifdef WIN32
	$(MKDIR) ../bin && for f in $(PREFIX)/bin/libjpeg*.dll ; do \
	    $(CP) $$f ../bin ; \
	    $(STRIP) ../bin/`basename $$f` ; \
	  done
	$(CP) $(JPEGDIR)/README ../doc/README-jpeg.txt
endif

$(JPEGDIR)/.ok:	archives/$(JPEGARCH)
	$(TAR) xzf $<
	touch $@

$(PREFIX)/lib/libtiff.a:	$(PREFIX)/lib/libjpeg.a
$(PREFIX)/lib/libtiff.a:	$(PREFIX)/lib/libz.a

$(PREFIX)/lib/libtiff.a:	$(LIBTIFF)/.ok
	cd $(LIBTIFF) && CC="$(CC) $(LDFLAGS)" ./configure --prefix=$(PREFIX) --host=$(HOST) \
	  --with-zlib-include-dir=$(PREFIX)/include --with-zlib-lib-dir=$(PREFIX)/lib \
	  --with-jpeg-include-dir=$(PREFIX)/include --with-jpeg-lib-dir=$(PREFIX)/lib
	cd $(LIBTIFF) && $(MAKE)
	cd $(LIBTIFF) && $(MAKE) install
ifdef WIN32
	$(MKDIR) ../bin && for f in $(PREFIX)/bin/libtiff*.dll ; do \
	    $(CP) $$f ../bin ; \
	    $(STRIP) ../bin/`basename $$f` ; \
	  done
	echo "$(LIBTIFF)" > ../doc/README-tiff.txt
	echo "" >> ../doc/README-tiff.txt
	echo "License :" >> ../doc/README-tiff.txt
	echo "" >> ../doc/README-tiff.txt
	cat $(LIBTIFF)/COPYRIGHT >> ../doc/README-tiff.txt
endif

$(LIBTIFF)/.ok:	archives/$(LIBTIFFARCH)
	$(TAR) xzf $<
	touch $@
	
$(PREFIX)/lib/libpng.a:	$(PREFIX)/lib/libz.a

$(PREFIX)/lib/libpng.a:	$(LIBPNG)/.ok
	cd $(LIBPNG) && CC="$(CC) $(LDFLAGS)" CPPFLAGS=-I$(PREFIX)/include LDFLAGS="-L$(PREFIX)/lib" ./configure --prefix=$(PREFIX) --host=$(HOST) --enable-silent-rules
	cd $(LIBPNG) && $(MAKE)
	cd $(LIBPNG) && $(MAKE) install
ifdef WIN32
	$(MKDIR) ../bin && for f in $(PREFIX)/bin/libpng*.dll ; do \
	    $(CP) $$f ../bin ; \
	    $(STRIP) ../bin/`basename $$f` ; \
	  done
	echo "$(LIBPNG)" > ../doc/README-libpng.txt
	echo "" >> ../doc/README-libpng.txt
	echo "License :" >> ../doc/README-libpng.txt
	echo "" >> ../doc/README-libpng.txt
	cat $(LIBPNG)/LICENSE >> ../doc/README-libpng.txt
endif

$(LIBPNG)/.ok:	archives/$(LIBPNGARCH)
	$(TAR) xzf $<
	touch $@

$(PREFIX)/lib/libz.a:	$(ZLIB)/.ok
	cd $(ZLIB) && $(MAKE) -fwin32/Makefile.gcc PREFIX=$(shell echo $(CC) | sed 's/^\(.*\)gcc/\1/') LOC="$(LDFLAGS) $(CFLAGS)"
	cd $(ZLIB) && INCLUDE_PATH=$(PREFIX)/include LIBRARY_PATH=$(PREFIX)/lib BINARY_PATH=$(PREFIX)/bin $(MAKE) install -fwin32/Makefile.gcc SHARED_MODE=1
ifdef WIN32
	$(MKDIR) ../bin && for f in $(PREFIX)/bin/zlib*.dll ; do \
	    $(CP) $$f ../bin ; \
	    $(STRIP) ../bin/`basename $$f` ; \
	  done
	$(CP) $(ZLIB)/README ../doc/README-zlib1.txt
endif

$(ZLIB)/.ok:	archives/$(ZLIBARCH)
	$(TAR) xzf $<
	touch $@

recoil:	$(RECOIL)/.ok

$(RECOIL)/.ok:	archives/$(RECOILARCH)
	$(TAR) xzf $<
	touch $@

archives/$(SDLDEVEL):
	@$(MKDIR) $(@D)
	cd $(@D) && $(GETURL) $(SDLDEVELURL)

archives/$(SDLIMAGEARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && $(GETURL) $(SDLIMAGEURL)

archives/$(SDLTTFARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && $(GETURL) $(SDLTTFURL)

archives/$(LIBPNGARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && ( $(GETURL) $(LIBPNGURL) || $(GETURL) $(LIBPNGURLALT) )

archives/$(JPEGARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && $(GETURL) $(JPEGURL)

archives/$(LIBTIFFARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && ( $(GETURL) $(LIBTIFFURL) || $(GETURL) $(LIBTIFFURLALT) )

archives/$(ZLIBARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && $(GETURL) $(ZLIBURL)

archives/$(FREETYPEARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && $(GETURL) $(FREETYPEURL)

archives/$(LUAARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && $(GETURL) $(LUAURL)

archives/$(RECOILARCH):
	@$(MKDIR) $(@D)
	cd $(@D) && ( $(GETURL) $(RECOILURL) || $(GETURL) $(RECOILURLALT) )

=== doc/Makefile ===
CP = cp

all:
	@echo "nothing to do..."

# fetch files from macports
MACPORTSPATH = $(shell which port | sed 's;/bin/port$$;;' )
DOCPATH = $(MACPORTSPATH)/share/doc
PACKAGES = libsdl2 libsdl2_image jpeg tiff webp
PACKAGSS += libsdl2_ttf freetype
PACKAGES += libpng zlib lua

READMES = $(PACKAGES:%=README-%.txt)

macports:	$(READMES)

clean:
	$(RM) $(READMES)

#	for p in $(PACKAGES) ; do \
	  echo $(DOCPATH)/$$p ; \
	  ls $(DOCPATH)/$$p ; \
	done

README-libsdl2.txt:	$(DOCPATH)/libsdl2/README-SDL.txt $(DOCPATH)/libsdl2/COPYING.txt
	p=$(@:README-%.txt=%) ; echo "$$p $$(port info --version $$p)" > $@
	cat $(DOCPATH)/libsdl2/README-SDL.txt >> $@
	cat $(DOCPATH)/libsdl2/COPYING.txt >> $@

README-libsdl2_image.txt:
	p=$(@:README-%.txt=%) ; echo "$$p $$(port info --version $$p)" > $@
	cat $(DOCPATH)/libsdl2_image/COPYING.txt >> $@

README-tiff.txt:	$(DOCPATH)/tiff/COPYRIGHT
	p=$(@:README-%.txt=%) ; echo "$$p $$(port info --version $$p)" > $@
	echo "" >> $@
	cat $(DOCPATH)/tiff/COPYRIGHT >> $@

README-lua.txt: $(DOCPATH)/lua/README $(DOCPATH)/lua/COPYRIGHT
	$(CP) $< $@
	echo "" >> $@
	cat $(DOCPATH)/lua/COPYRIGHT >> $@

README-libpng.txt:	$(DOCPATH)/libpng/LICENSE
	echo "libpng $$(port info --version libpng)" > $@
	echo "" >> $@
	echo "License :" >> $@
	echo "" >> $@
	cat $< >> $@

README-%.txt: $(DOCPATH)/%/README
	p=$(@:README-%.txt=%) ; echo "$$p $$(port info --version $$p)" > $@
	echo "" >> $@
	cat $< >> $@
	f=$(DOCPATH)/$(@:README-%.txt=%)/COPYING ; \
	  if [ -f "$$f" ] ; then echo "License :" >> $@ ; cat "$$f" >> $@ ; fi

=== install/Makefile ===
# (c) 2018 Thomas Bernard

MAKENSIS = makensis
UNZIP = unzip -o
SED = sed

API ?= sdl

GIT_REVISION := $(shell cat ../src/version.c | cut -f 2 -d '"')
LABEL := $(shell cat ../src/pversion.c | cut -f 2 -d '"')
VERSION := $(subst wip.,wip,$(LABEL).$(GIT_REVISION))

SOURCES = ../src-$(VERSION).tgz
INSTALLER = grafx2-$(API)-$(VERSION).win32.exe

all:	$(INSTALLER)

$(INSTALLER):	WinInstaller.nsi $(SOURCES) $(VERSIONTAG)
ifdef WIN32CROSS
	for f in ../doc/*.txt; do unix2dos $$f ; done
endif
	$(SED) -e 's/VERSION .*/VERSION $(VERSION)/' -e 's/API .*/API $(API)/' $< | $(MAKENSIS) -
ifdef WIN32CROSS
	for f in ../doc/*.txt; do dos2unix $$f ; done
endif

$(SOURCES): $(wildcard ../src/*.c) $(wildcard ../src/*.h)
	cd ../src && WIN32CROSS=1 $(MAKE) $(SOURCES)

=== src/Makefile ===
#  Grafx2 - The Ultimate 256-color bitmap paint program
#  
#  Copyright 2018 Thomas Bernard
#  Copyright 2012 Franck Charlet
#  Copyright 2011 Pawel Góralski
#  Copyright 2009 Per Olofsson
#  Copyright 2008 Peter Gordon
#  Copyright 2008-2010 Yves Rizoud
#  Copyright 2007-2010 Adrien Destugues
#  Copyright 1996-2001 Sunset Design (Guillaume Dorme & Karl Maritaud)
#  
#  Grafx2 is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; version 2
#  of the License.
#  
#  Grafx2 is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with Grafx2; if not, see <http://www.gnu.org/licenses/>

# Overridable defaults
  PREFIX ?= /usr/local
  exec_prefix = $(PREFIX)
  bindir = $(exec_prefix)/bin
  datarootdir = $(PREFIX)/share
  datadir = $(datarootdir)
  pixmapdir = $(datarootdir)/icons/hicolor/scalable/apps

# Compile with OPTIM=0 to disable gcc optimizations, to enable debug.
  STRIP = strip

# Detect GIT revision
ifeq (true,$(shell git rev-parse --is-inside-work-tree))
  GIT_REVISION = $(shell git rev-list --count 1af8c74f53110e349d8f0d19b14599281913f71f..)
  ifneq (,$(CI_COMMIT_REF_NAME))
    GIT_BRANCH = $(CI_COMMIT_REF_NAME)
  else
  ifneq (,$(TRAVIS_BRANCH))
    GIT_BRANCH = $(TRAVIS_BRANCH)
  else
    GIT_BRANCH = $(shell git rev-parse --abbrev-ref HEAD)
  endif
  endif
  ifneq (master,$(GIT_BRANCH))
    GIT_REVISION := $(GIT_REVISION)-$(GIT_BRANCH)
  endif
else
  # outside git repository : get version stored in version.c
  GIT_REVISION := $(shell cat version.c | cut -f 2 -d '"')
endif

  REVISION_CACHE = .revision.cache
  RES := $(shell if [ ! -f $(REVISION_CACHE) ] || [ "`cat $(REVISION_CACHE)`" != "$(GIT_REVISION)" ] ; then echo "$(GIT_REVISION)" > $(REVISION_CACHE) ; fi )

ifneq (,$(LABEL))
  LABEL_CACHE = .label.cache
  RES := $(shell if [ ! -f $(LABEL_CACHE) ] || [ "`cat $(LABEL_CACHE)`" != "$(LABEL)" ] ; then echo "$(LABEL)" > $(LABEL_CACHE) ; fi )
else
  # get label stored in pversion.c
  LABEL := $(shell cat pversion.c | cut -f 2 -d '"')
endif

  VERSIONTAG = $(subst wip.,wip,$(LABEL).$(GIT_REVISION))

  CFLAGS_CACHE = $(OBJDIR)/.cflags.cache

  RECOILVER = 4.3.1

# Video / input API used
  API ?= sdl

# At the moment support for TTF requires SDL or SDL2
  ifneq (sdl,$(findstring sdl,$(API)))
    NOTTF = 1
  endif

### PLATFORM DETECTION AND CONFIGURATION ###

PLATFORMOBJ =

TAR = tar
# Note : --transform option was added in GNU tar version 1.15.91
TARTRANSFORM = --strip=1 --transform 's,^,grafx2/,g'

# default to gcc compiler
ifeq (default,$(origin CC))
  CC = gcc
endif
PKG_CONFIG ?= pkg-config

# There is no uname under windows, but we can guess we are there with the COMSPEC env.var
# Windows specific
ifdef COMSPEC
  DELCOMMAND = rm -f
  MKDIR = mkdir -p
  RMDIR = rmdir --ignore-fail-on-non-empty
  CP = cp
  BIN = ../bin/grafx2.exe
  GENERATEDOCBIN = ../bin/generatedoc.exe
  COPT = -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -g -ggdb `sdl-config --cflags` $(TTFCOPT) $(JOYCOPT) $(LUACOPT)
  LOPT = `sdl-config --libs` -lSDL_image $(TTFLOPT) -lpng -lz $(LUALOPT)
  LUALOPT = -llua
  OBJDIR = ../obj/win32
  # Resources (icon)
  WINDRES = windres.exe
  PLATFORMOBJ = winres.o
  PLATFORM = win32
  #some misc files we have to add to the release archive under windows.
  PLATFORMFILES = bin/SDL.dll bin/SDL_image.dll $(wildcard ../bin/libpng*.dll) $(wildcard ../bin/libjpeg*.dll) bin/zlib1.dll $(TTFLIBS)
  PLATFORMFILES += bin/libtiff-5.dll
  ZIP = zip
else

# default for GENERATEDOCBIN
  GENERATEDOCBIN = ../bin/generatedoc
#For all other platforms, we can rely on uname
  PLATFORM = $(shell uname)

  ifeq ($(PLATFORM),AmigaOS) # 1
    #AmigaOS (3 or 4) specific
    DELCOMMAND = rm -rf
    MKDIR = mkdir -p
    RMDIR = rmdir --ignore-fail-on-non-empty
    CP = cp
    BIN = ../bin/grafx2
    COPT = -Wall -gstabs $(shell sdl-config --cflags) $(TTFCOPT)
    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT) -lft2
    OBJDIR = ../obj/amiga
    ZIP = lha
    ZIPOPT = a
    NOTTF = 1

  else
  ifeq ($(PLATFORM),Darwin) # 2
    #Mac OS X specific
    # to statically link non system libraries
    OSX_STATIC ?= 1

    # Darwin / OS X versions :
    #  6    => 10.2         ppc only
    #  7    => 10.3         ppc only
    #  8    => 10.4 Tiger   (ppc/i386)
    #  9    => 10.5 Leopard (ppc/i386)
    # 10    => 10.6 Snow Leopard (i386 only)
    MACHINE = $(shell gcc -dumpmachine)
    DARWINVER = $(shell gcc -dumpmachine | sed 's/.*darwin\([0-9]*\).*/\1/' )
    ifeq (greater, $(shell [ $(DARWINVER) -gt 9 ] && echo "greater"))
    MACOSX_ARCH = -arch x86_64 -arch i386
    #MACOSX_LION = 1
    else
    ifeq (9, $(DARWINVER))
    MACOSX_ARCH = -arch ppc -arch i386
    else
    ifneq ( ,$(findstring(powerpc, $(MACHINE))))
    MACOSX_ARCH = -arch ppc
    else
    MACOSX_ARCH = -arch i386
    endif
    endif
    endif

ifdef MACOSX_LION
MACOSX_SYSROOT = /Developer/SDKs/MacOSX10.6.sdk
else
MACOSX_SYSROOT = /Developer/SDKs/MacOSX10.4u.sdk
endif

    DELCOMMAND = rm -rf
    MKDIR = mkdir -p
    RMDIR = rmdir --ignore-fail-on-non-empty
    # Force it
    OPTIM = 3
    CP = cp
    ZIP = zip
    TAR = $(shell which bsdtar || which gnutar || which tar)
    TARTRANSFORM = $(shell if $(TAR) --version | grep 'GNU tar' > /dev/null ; then \
                             echo "--strip=1 --transform 's,^,grafx2/,g'" ; else \
                             echo "-s '/\.\./grafx2/'" ; fi )
    PLATFORMFILES = ../share/grafx2/gfx2.png
    # Where the SDL frameworks are located
    FWDIR = /Library/Frameworks
    BIN = ../bin/grafx2-$(API)

ifeq ($(API),sdl)
    SDLCONFIG := $(shell which sdl-config)
ifneq ($(SDLCONFIG), )
    # these are for use with macports
    SDLCOPT = $(shell sdl-config --cflags)
  ifeq ($(OSX_STATIC), 1)
    SDLLOPT = $(shell sdl-config --static-libs | sed 's/-lSDL //' | sed 's/-lX[^ ]*//g' | sed 's/-L[^ ]*//g')
    SDLLIBDIR = $(shell $(PKG_CONFIG) --variable=libdir SDL_image)
    #SDLLOPT += $(SDLLIBDIR)/libSDL.a
    SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL_image.dylib $(SDLLIBDIR)/libSDL_ttf.dylib | grep -v SDL | cut -d'.' -f 1))
    SDLLOPT += $(SDLLIBDIR)/libSDL_image.a
    TTFLOPT =
    SDLLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL_ttf)/libSDL_ttf.a
  else
    SDLLOPT = $(shell sdl-config --libs) $(shell $(PKG_CONFIG) --libs SDL_image)
  endif
else
    # these are for use with Mac OS X native frameworks
    #-framework SDL_ttf 
    SDLLOPT = -isysroot $(MACOSX_SYSROOT) $(MACOSX_ARCH) -L/usr/lib -framework SDL -framework SDL_image -framework Cocoa -framework Carbon -framework OpenGL
    SDLCOPT = $(MACOSX_ARCH) -I$(FWDIR)/SDL.framework/Headers -I$(FWDIR)/SDL_image.framework/Headers -I$(FWDIR)/SDL_ttf.framework/Headers -D_THREAD_SAFE
endif
endif
ifeq ($(API),sdl2)
    SDLCOPT = $(shell sdl2-config --cflags)
    #TTFCOPT = $(shell $(PKG_CONFIG) --cflags SDL2_ttf)
  ifeq ($(OSX_STATIC), 1)
    SDLLOPT = $(shell sdl2-config --static-libs | sed 's/-lSDL2//' | sed 's/-L[^ ]*//')
    SDLLIBDIR = $(shell $(PKG_CONFIG) --variable=libdir SDL2_image)
    SDLLOPT += $(SDLLIBDIR)/libSDL2.a
    # trick to get all dependencies
    SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL2_image.dylib $(SDLLIBDIR)/libSDL2_ttf.dylib | grep -v SDL2 | cut -d'.' -f 1))
    SDLLOPT += $(SDLLIBDIR)/libSDL2_image.a
    TTFLOPT =
    SDLLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL2_ttf)/libSDL2_ttf.a
  else
    SDLLOPT = $(shell sdl2-config --libs) $(shell $(PKG_CONFIG) --libs SDL2_image)
    SDLLOPT += -Wl,-framework,Cocoa
    TTFLOPT = $(shell $(PKG_CONFIG) --libs SDL2_ttf)
  endif
endif

    # these are for use with macports
    LUAPKG := $(shell for p in lua lua5.3 lua-5.3 lua53 lua5.2 lua-5.2 lua52 lua5.1 lua-5.1 lua51 ; do $(PKG_CONFIG) --exists $$p && echo $$p && break ; done)
ifneq ($(LUAPKG), )
    ifeq ($(OSX_STATIC),1)
      LUACOPT = $(shell $(PKG_CONFIG) $(LUAPKG) --cflags | sed 's/-I/-idirafter/')
      LUALOPT = $(shell $(PKG_CONFIG) $(LUAPKG) --variable=libdir)/liblua.a
    else
      LUACOPT = $(shell $(PKG_CONFIG) $(LUAPKG) --cflags)
      LUALOPT = $(shell $(PKG_CONFIG) $(LUAPKG) --libs)
    endif
else
    # these are for use with Mac OS X native frameworks
    LUACOPT = -I$(FWDIR)/Lua.framework/Headers
ifdef MACOSX_LION
    LUALOPT = -framework lua
else
    LUALOPT = -llua 
endif
endif

    # these are for everyone
    COPT = -D_DARWIN_C_SOURCE -D__macosx__ -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -std=c99 -g $(LUACOPT) $(SDLCOPT) $(TTFCOPT) -I/usr/include
ifeq ($(NO_X11),1)
    COPT += -DNO_X11
endif
ifdef MACOSX_LION
    LOPT = $(SDLLOPT) $(LUALOPT) -framework libpng14 -lz
else
    LOPT = $(SDLLOPT) $(LUALOPT)
    ifneq ($(OSX_STATIC), 1)
      LOPT += $(TTFLOPT)
    endif
    LIBPNGCONFIG := $(shell libpng-config)
ifneq ($(LIBPNGCONFIG), )
    COPT += $(shell libpng-config --cflags)
    ifneq ($(OSX_STATIC), 1)
    LOPT += $(shell libpng-config --ldflags)
    endif
else
    LOPT += -lpng
endif
    ifneq ($(OSX_STATIC), 1)
    LOPT += -lz -ltiff
    endif
endif
    COPT += -DENABLE_FILENAMES_ICONV
    LOPT += -liconv
ifeq ($(API),x11)
    LOPT += -Wl,-framework,CoreFoundation
endif
    # Use gcc for compiling. Use ncc to build a callgraph and analyze the code.
    #CC = nccgen -ncgcc -ncld -ncfabs
    OBJDIR = ../obj/macosx
    PLATFORMOBJ = pasteboard.o
ifeq ($(API),sdl)
    PLATFORMOBJ += SDLMain.o
endif
    FCLOPT = 
    MACAPPEXE = Grafx2.app/Contents/MacOS/Grafx2
    #NOTTF = 1
  else
  ifeq ($(PLATFORM),AROS) # 3
    #AROS specific
    DELCOMMAND = rm -rf
    MKDIR = mkdir -p
    RMDIR = rmdir --ignore-fail-on-non-empty
    CP = cp
    BIN = ../bin/grafx2
    COPT = -Wall -g $(shell sdl-config --cflags) $(TTFCOPT)
    LOPT = -lSDL_image $(shell sdl-config --libs) -lpng -ljpeg -lz $(TTFLOPT) -lfreetype2shared
    OBJDIR = ../obj/aros
    STRIP = strip --strip-unneeded --remove-section .comment
    ZIP = lha
    ZIPOPT = a

  else
  ifeq ($(PLATFORM),MorphOS) # 4
    #MorphOS specific
    DELCOMMAND = rm -rf
    MKDIR = mkdir -p
    RMDIR = rmdir --ignore-fail-on-non-empty
    CP = cp
    BIN = ../bin/grafx2
    COPT = -Wall -gstabs $(shell sdl-config --cflags) $(TTFCOPT)
    LOPT = -lSDL_image $(shell sdl-config --libs) -lpng -ljpeg -lz $(TTFLOPT)
    OBJDIR = ../obj/morphos
    ZIP = lha
    ZIPOPT = a
    PLATFORMFILES = ../misc/grafx2.info

  else
  ifeq ($(PLATFORM),BeOS) # 6
    #BeOS specific
    DELCOMMAND = rm -rf
    MKDIR = mkdir -p
    RMDIR = rmdir --ignore-fail-on-non-empty
    CP = cp
    BIN = ../bin/grafx2
    COPT = -W -Wall -g $(shell sdl-config --cflags) $(TTFCOPT) -I/boot/home/config/include
    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT)
    OBJDIR = ../obj/beos
    ZIP = zip

  else
  ifeq ($(PLATFORM),Haiku) # 7
    #Haiku specific
    DELCOMMAND = rm -rf
    MKDIR = mkdir -p
    RMDIR = rmdir --ignore-fail-on-non-empty
    CP = cp
    BIN = ../bin/grafx2
    PLATFORMOBJ = haiku.o
    ifeq ($(NOLUA),1)
      LUACOPT =
      LUALOPT =
    else
      LUAPKG=lua
      LUACOPT = -D__ENABLE_LUA__ $(shell $(PKG_CONFIG) $(LUAPKG) --cflags)
      LUALOPT = $(shell $(PKG_CONFIG) $(LUAPKG) --libs)
    endif
    COPT = -W -Wall -g $(shell sdl-config --cflags) $(TTFCOPT) -I/boot/common/include $(LUACOPT)
    COPT += -DENABLE_FILENAMES_ICONV
    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT) -lfreetype -lbe $(LUALOPT) -liconv -ltiff
    #Append the gcc kind to the objdir (gcc2 or gcc4) to avoid conflicts when switching from one to other.
    OBJKIND = $(shell gcc -dumpversion)
    OBJDIR = ../obj/haiku/$(OBJKIND)
    ZIP = zip

=== tools/Makefile ===
DOXYGEN = doxygen
TAR = tar

ifneq ($(shell test -f ../src/version.c && echo exists),exists)
$(error please build grafx2 first. missing version.c file.)
endif

GIT_REVISION = $(shell cat ../src/version.c | cut -f 2 -d '"')
LABEL = $(shell cat ../src/pversion.c | cut -f 2 -d '"')
VERSION = $(subst wip.,wip,$(LABEL).$(GIT_REVISION))

SOURCES = $(wildcard ../src/*.c) $(wildcard ../src/*.h)

DOCARCHIVE = ../grafx2-$(VERSION)-doxygen.tgz

.PHONY:	all gifanalyzer sdl_image_test test_iff doxygen

all:	gifanalyzer sdl_image_test test_iff

gifanalyzer:
	$(MAKE) -C $@

sdl_image_test:
	$(MAKE) -C $@

test_iff:
	$(MAKE) -C $@

doxygenarchive:	$(DOCARCHIVE)

$(DOCARCHIVE):	../doc/doxygen/html/index.html
	cd ../doc && $(TAR) czf $@ doxygen/

doxygen:	../doc/doxygen/html/index.html

../doc/doxygen/html/index.html:	Doxyfile $(SOURCES)
	$(DOXYGEN)

Doxyfile:	../src/version.c ../src/pversion.c
	sed -e 's/^\(PROJECT_NUMBER[ ]*=[ ]*\).*$$/\1 "$(VERSION)"/' $@ > $@.tmp
	mv $@.tmp $@

=== tools/gifanalyzer/Makefile ===
CFLAGS=-Wall
#LDLIBS=-lm

.PHONY:	all clean

all:	gifanalyzer

clean:
	$(RM) *.o gifanalyzer

gifanalyzer:	gifanalyzer.o

=== tools/sdl_image_test/Makefile ===
CFLAGS = -Wall -O -g

ifeq ($(API),sdl2)
# SDL 2.x
SDLCONFIG = sdl2-config
SDLIMAGE = SDL2_image
BIN = showimage-sdl2
CFLAGS += -DUSE_SDL2
else
# SDL 1.2.x
SDLCONFIG = sdl-config
SDLIMAGE = SDL_image
BIN = showimage
CFLAGS += -DUSE_SDL
endif

ifdef WIN32CROSS
CC = $(shell which i686-w64-mingw32-gcc || which mingw32-gcc)
PKGCONFIG_PATH = $(shell if [ -d ../../3rdparty/usr ] ; then echo "PKG_CONFIG_LIBDIR=$${PWD}/../../3rdparty/usr/lib/pkgconfig" ; fi )
PKGCONFIG = $(PKGCONFIG_PATH) $(shell which i686-w64-mingw32-pkg-config || which mingw32-pkg-config || which pkg-config)
SDLCONFIG = $(shell which ../../3rdparty/usr/bin/sdl-config || which /usr/local/cross-tools/i386-mingw32/bin/sdl-config)
BIN := $(BIN).exe
else
PKGCONFIG = pkg-config
endif

CFLAGS += $(shell $(SDLCONFIG) --cflags)

LDLIBS = $(shell $(SDLCONFIG) --libs)

ifdef WIN32CROSS
LDLIBS += -lSDL_image
else
LDLIBS += $(shell $(PKGCONFIG) $(SDLIMAGE) --libs-only-l)

LDFLAGS = $(shell $(PKGCONFIG) $(SDLIMAGE) --libs-only-L)
endif

.PHONY:	all clean

all:	$(BIN)

clean:
	$(RM) $(BIN) *.o

$(BIN):	$(BIN).o

$(BIN).o:	showimage.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

=== debian/changelog ===
grafx2 (2.6-2) unstable; urgency=medium

  * Patch src/fileformats to fix png saving.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 21 Jan 2019 13:44:37 +0100

grafx2 (2.6-1) unstable; urgency=medium

  * New upstream version. (Closes: #918725)
  * debian/control: add libtiff-dev.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 10 Jan 2019 16:51:38 +0100

=== debian/control ===
Source: grafx2
Section: graphics
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libsdl2-dev, libsdl2-image-dev, libsdl2-ttf-dev, liblua5.3-dev | liblua5.1-0-dev, libpng-dev, pkg-config, libfontconfig1-dev, dh-exec, libtiff-dev
Standards-Version: 4.2.1
Homepage: http://pulkomandy.tk/projects/GrafX2

Package: grafx2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-tuffy
Description: ultimate 256-color bitmap paint program
 This is a bitmap paint program that allows you to draw in more than 60 video
 resolutions (from 320x200 to 1024x768, including most of the standard Amiga
 resolutions: 320x256, 320x512, 640x256, 640x512, and more, provided your
 videocard knows how to handle them).
 .
 This program is dedicated to everybody who knows what a single pixel is. Its
 layout is not very different from the famous Deluxe Paint or Brilliance, so
 it will be quite easy to handle it if you know at least one of these programs.
 If you aren't used to the art of drawing with up to 256 colors, it will be a
 little more difficult for you, but you should give it a try (or more, because
 most of the power of this program won't show up on the first try).

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export NORECOIL=1
export API=sdl2

%:
	dh $@ --sourcedirectory=src -- depend

override_dh_auto_install:
	@echo Do not use install target of upstream Makefile

## grafx2 2.7

=== src/Makefile ===
--- 
+++ 
@@ -22,6 +22,9 @@
 #  You should have received a copy of the GNU General Public License
 #  along with Grafx2; if not, see <http://www.gnu.org/licenses/>
 
+# make V=1   to enable verbose building
+V ?= 0
+
 # Overridable defaults
   PREFIX ?= /usr/local
   exec_prefix = $(PREFIX)
@@ -68,7 +71,7 @@
 
   CFLAGS_CACHE = $(OBJDIR)/.cflags.cache
 
-  RECOILVER = 4.3.1
+  RECOILVER = 5.0.0
 
 # Video / input API used
   API ?= sdl
@@ -94,25 +97,56 @@
 
 # There is no uname under windows, but we can guess we are there with the COMSPEC env.var
 # Windows specific
+ifdef ComSpec
+# sometimes, it is ComSpec, sometimes it is COMSPEC
+COMSPEC = $(ComSpec)
+endif
 ifdef COMSPEC
   DELCOMMAND = rm -f
   MKDIR = mkdir -p
   RMDIR = rmdir --ignore-fail-on-non-empty
   CP = cp
-  BIN = ../bin/grafx2.exe
+  BIN = ../bin/grafx2-$(API).exe
   GENERATEDOCBIN = ../bin/generatedoc.exe
-  COPT = -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -g -ggdb `sdl-config --cflags` $(TTFCOPT) $(JOYCOPT) $(LUACOPT)
-  LOPT = `sdl-config --libs` -lSDL_image $(TTFLOPT) -lpng -lz $(LUALOPT)
+  COPT = -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -g -ggdb
+  COPT += $(LUACOPT)
+  LOPT = -mwindows
+  LOPT += $(LUALOPT)
+  ifeq ($(API),sdl)
+  SDLCONFIG ?= $(shell which ../3rdparty/usr-win32/bin/sdl-config || which sdl-config)
+  COPT += $(shell $(SDLCONFIG) --cflags) $(TTFCOPT) $(JOYCOPT)
+  LOPT += $(shell $(SDLCONFIG) --libs) -lSDL_image $(TTFLOPT)
+  PLATFORMFILES = bin/SDL.dll bin/SDL_image.dll
+  endif
+  ifeq ($(API),sdl2)
+  SDLC2ONFIG ?= $(shell which ../3rdparty/usr-win32/bin/sdl2-config || which sdl2-config)
+  COPT += $(shell $(SDL2CONFIG) --cflags) $(TTFCOPT) $(JOYCOPT)
+  LOPT += $(shell $(SDL2CONFIG) --libs) -lSDL2_image $(TTFLOPT)
+  PLATFORMFILES = bin/SDL2.dll bin/SDL2_image.dll
+  endif
+  ifeq ($(API),win32)
+  COPT += -I../3rdparty/usr-win32/include $(TTFCOPT)
+  LOPT += -L../3rdparty/usr-win32/lib -lgdi32 -lcomdlg32
+  PLATFORMFILES =
+  endif
+  LOPT += -lmpr
+  LOPT += -ltiff
+  LOPT += -lpng -lz
   LUALOPT = -llua
-  OBJDIR = ../obj/win32
+  OBJDIR = ../obj/win32-$(API)
   # Resources (icon)
   WINDRES = windres.exe
   PLATFORMOBJ = winres.o
   PLATFORM = win32
   #some misc files we have to add to the release archive under windows.
-  PLATFORMFILES = bin/SDL.dll bin/SDL_image.dll $(wildcard ../bin/libpng*.dll) $(wildcard ../bin/libjpeg*.dll) bin/zlib1.dll $(TTFLIBS)
+  PLATFORMFILES += $(wildcard ../bin/libpng*.dll) $(wildcard ../bin/libjpeg*.dll) bin/zlib1.dll $(TTFLIBS)
   PLATFORMFILES += bin/libtiff-5.dll
+  ifdef APPVEYOR
+  ZIP = 7z
+  ZIPOPT = a
+  else
   ZIP = zip
+  endif
 else
 
 # default for GENERATEDOCBIN
@@ -184,22 +218,28 @@
     # Where the SDL frameworks are located
     FWDIR = /Library/Frameworks
     BIN = ../bin/grafx2-$(API)
+    TESTSBIN = ../bin/tests-$(API)
+    PKG_CONFIG_PATH ?= $(shell if [ -d ../3rdparty/usr/lib/pkgconfig ] ; then echo "$${PWD}/../3rdparty/usr/lib/pkgconfig" ; fi )
+ifneq ($(PKG_CONFIG_PATH), )
+    PKG_CONFIG := PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG)
+endif
 
 ifeq ($(API),sdl)
-    SDLCONFIG := $(shell which sdl-config)
+    SDLCONFIG := $(shell which ../3rdparty/usr/bin/sdl-config || which sdl-config)
 ifneq ($(SDLCONFIG), )
     # these are for use with macports
-    SDLCOPT = $(shell sdl-config --cflags)
+    SDLCOPT = $(shell $(SDLCONFIG) --cflags)
   ifeq ($(OSX_STATIC), 1)
-    SDLLOPT = $(shell sdl-config --static-libs | sed 's/-lSDL //' | sed 's/-lX[^ ]*//g' | sed 's/-L[^ ]*//g')
+    SDLLOPT = $(shell $(SDLCONFIG) --static-libs | sed 's/-lSDL //' | sed 's/-lX[^ ]*//g' | sed 's/-L[^ ]*//g')
     SDLLIBDIR = $(shell $(PKG_CONFIG) --variable=libdir SDL_image)
     #SDLLOPT += $(SDLLIBDIR)/libSDL.a
     SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL_image.dylib $(SDLLIBDIR)/libSDL_ttf.dylib | grep -v SDL | cut -d'.' -f 1))
     SDLLOPT += $(SDLLIBDIR)/libSDL_image.a
-    TTFLOPT =
-    SDLLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL_ttf)/libSDL_ttf.a
-  else
-    SDLLOPT = $(shell sdl-config --libs) $(shell $(PKG_CONFIG) --libs SDL_image)
+    TTFLOPT = $(shell if [ -f ../3rdparty/usr/lib/libfreetype.dylib ] && \
+      otool -L ../3rdparty/usr/lib/libfreetype.dylib | cut -f 2 | grep -q ^/usr/lib/libbz2 ; then echo "-lbz2" ; fi )
+    TTFLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL_ttf)/libSDL_ttf.a
+  else
+    SDLLOPT = $(shell $(SDLCONFIG) --libs) $(shell $(PKG_CONFIG) --libs SDL_image)
   endif
 else
     # these are for use with Mac OS X native frameworks
@@ -209,24 +249,30 @@
 endif
 endif
 ifeq ($(API),sdl2)
-    SDLCOPT = $(shell sdl2-config --cflags)
+    SDL2CONFIG := $(shell which ../3rdparty/usr/bin/sdl2-config || which sdl2-config)
+    SDLCOPT = $(shell $(SDL2CONFIG) --cflags)
     #TTFCOPT = $(shell $(PKG_CONFIG) --cflags SDL2_ttf)
   ifeq ($(OSX_STATIC), 1)
-    SDLLOPT = $(shell sdl2-config --static-libs | sed 's/-lSDL2//' | sed 's/-L[^ ]*//')
+    SDLLOPT = $(shell $(SDL2CONFIG) --static-libs | sed 's/-lSDL2//' | sed 's/-L[^ ]*//')
     SDLLIBDIR = $(shell $(PKG_CONFIG) --variable=libdir SDL2_image)
     SDLLOPT += $(SDLLIBDIR)/libSDL2.a
     # trick to get all dependencies
     SDLLOPT += $(addsuffix .a, $(shell ../tools/osx_find_dependencies.sh $(SDLLIBDIR)/libSDL2_image.dylib $(SDLLIBDIR)/libSDL2_ttf.dylib | grep -v SDL2 | cut -d'.' -f 1))
     SDLLOPT += $(SDLLIBDIR)/libSDL2_image.a
-    TTFLOPT =
-    SDLLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL2_ttf)/libSDL2_ttf.a
-  else
-    SDLLOPT = $(shell sdl2-config --libs) $(shell $(PKG_CONFIG) --libs SDL2_image)
+    TTFLOPT = $(shell if [ -f ../3rdparty/usr/lib/libfreetype.dylib ] && \
+      otool -L ../3rdparty/usr/lib/libfreetype.dylib | cut -f 2 | grep -q ^/usr/lib/libbz2 ; then echo "-lbz2" ; fi )
+    TTFLOPT += $(shell $(PKG_CONFIG) --variable=libdir SDL2_ttf)/libSDL2_ttf.a
+  else
+    SDLLOPT = $(shell $(SDL2CONFIG) --libs) $(shell $(PKG_CONFIG) --libs SDL2_image)
     SDLLOPT += -Wl,-framework,Cocoa
     TTFLOPT = $(shell $(PKG_CONFIG) --libs SDL2_ttf)
   endif
 endif
 
+ifneq ($(shell if [ -f ../3rdparty/usr/lib/liblua.a ] ; then echo "3rdparty"; fi), )
+    LUACOPT = -I../3rdparty/usr/include
+    LUALOPT = ../3rdparty/usr/lib/liblua.a
+else
     # these are for use with macports
     LUAPKG := $(shell for p in lua lua5.3 lua-5.3 lua53 lua5.2 lua-5.2 lua52 lua5.1 lua-5.1 lua51 ; do $(PKG_CONFIG) --exists $$p && echo $$p && break ; done)
 ifneq ($(LUAPKG), )
@@ -246,6 +292,7 @@
     LUALOPT = -llua 
 endif
 endif
+endif
 
     # these are for everyone
     COPT = -D_DARWIN_C_SOURCE -D__macosx__ -W -Wall -Wdeclaration-after-statement -O$(OPTIM) -std=c99 -g $(LUACOPT) $(SDLCOPT) $(TTFCOPT) -I/usr/include
@@ -255,15 +302,12 @@
 ifdef MACOSX_LION
     LOPT = $(SDLLOPT) $(LUALOPT) -framework libpng14 -lz
 else
-    LOPT = $(SDLLOPT) $(LUALOPT)
+    LOPT = $(SDLLOPT) $(LUALOPT) $(TTFLOPT)
+    LIBPNGCONFIG := $(shell which ../3rdparty/usr/bin/libpng-config || which libpng-config)
+ifneq ($(LIBPNGCONFIG), )
+    COPT += $(shell $(LIBPNGCONFIG) --cflags)
     ifneq ($(OSX_STATIC), 1)
-      LOPT += $(TTFLOPT)
-    endif
-    LIBPNGCONFIG := $(shell libpng-config)
-ifneq ($(LIBPNGCONFIG), )
-    COPT += $(shell libpng-config --cflags)
-    ifneq ($(OSX_STATIC), 1)
-    LOPT += $(shell libpng-config --ldflags)
+    LOPT += $(shell $(LIBPNGCONFIG) --ldflags)
     endif
 else
     LOPT += -lpng
@@ -286,6 +330,7 @@
 endif
     FCLOPT = 
     MACAPPEXE = Grafx2.app/Contents/MacOS/Grafx2
+    APPZIPNAME = Grafx2.app-$(shell uname -m | sed 's/Power Macintosh/powerpc/')-$(API)-$(VERSIONTAG).zip
     #NOTTF = 1
   else
   ifeq ($(PLATFORM),AROS) # 3
@@ -295,63 +340,3 @@
     RMDIR = rmdir --ignore-fail-on-non-empty
     CP = cp
     BIN = ../bin/grafx2
-    COPT = -Wall -g $(shell sdl-config --cflags) $(TTFCOPT)
-    LOPT = -lSDL_image $(shell sdl-config --libs) -lpng -ljpeg -lz $(TTFLOPT) -lfreetype2shared
-    OBJDIR = ../obj/aros
-    STRIP = strip --strip-unneeded --remove-section .comment
-    ZIP = lha
-    ZIPOPT = a
-
-  else
-  ifeq ($(PLATFORM),MorphOS) # 4
-    #MorphOS specific
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    BIN = ../bin/grafx2
-    COPT = -Wall -gstabs $(shell sdl-config --cflags) $(TTFCOPT)
-    LOPT = -lSDL_image $(shell sdl-config --libs) -lpng -ljpeg -lz $(TTFLOPT)
-    OBJDIR = ../obj/morphos
-    ZIP = lha
-    ZIPOPT = a
-    PLATFORMFILES = ../misc/grafx2.info
-
-  else
-  ifeq ($(PLATFORM),BeOS) # 6
-    #BeOS specific
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    BIN = ../bin/grafx2
-    COPT = -W -Wall -g $(shell sdl-config --cflags) $(TTFCOPT) -I/boot/home/config/include
-    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT)
-    OBJDIR = ../obj/beos
-    ZIP = zip
-
-  else
-  ifeq ($(PLATFORM),Haiku) # 7
-    #Haiku specific
-    DELCOMMAND = rm -rf
-    MKDIR = mkdir -p
-    RMDIR = rmdir --ignore-fail-on-non-empty
-    CP = cp
-    BIN = ../bin/grafx2
-    PLATFORMOBJ = haiku.o
-    ifeq ($(NOLUA),1)
-      LUACOPT =
-      LUALOPT =
-    else
-      LUAPKG=lua
-      LUACOPT = -D__ENABLE_LUA__ $(shell $(PKG_CONFIG) $(LUAPKG) --cflags)
-      LUALOPT = $(shell $(PKG_CONFIG) $(LUAPKG) --libs)
-    endif
-    COPT = -W -Wall -g $(shell sdl-config --cflags) $(TTFCOPT) -I/boot/common/include $(LUACOPT)
-    COPT += -DENABLE_FILENAMES_ICONV
-    LOPT = $(shell sdl-config --libs) -lSDL_image -lpng -ljpeg -lz $(TTFLOPT) -lfreetype -lbe $(LUALOPT) -liconv -ltiff
-    #Append the gcc kind to the objdir (gcc2 or gcc4) to avoid conflicts when switching from one to other.
-    OBJKIND = $(shell gcc -dumpversion)
-    OBJDIR = ../obj/haiku/$(OBJKIND)
-    ZIP = zip
-

=== misc/c64viewer/Makefile ===
AS=ophis
ASFLAGS=-l $*.lst -m $*.map

all:	picview.prg final.prg c64picview_inc.h

%.prg:	%.asm
	$(AS) $(ASFLAGS) -o $@ $<

final.prg:	picview.prg 30.bin 20.bin screen.bin 10.bin bitmap.bin 30.bin color.bin 42.bin 10.bin 00.bin
	cat $+ > $@

c64picview_inc.h:	picview.prg
	xxd -i $< | sed 's/^unsigned char/static unsigned char/'| sed '$$ d' > $@

=== debian/changelog ===
grafx2 (2.7-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 17 Mar 2020 23:34:22 -0700

grafx2 (2.7-1) unstable; urgency=medium

  * New upstream version.
  * Add Vcs fields.
  * Bump standards version to 4.5.0.
  * debian/patches: dropped.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sat, 01 Feb 2020 13:19:22 +0100

grafx2 (2.6+git20191023-1) experimental; urgency=medium

  * New upstream version.
  * Bump standards version to 4.4.1.
  * d/copyright: update to machine readable format.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 23 Oct 2019 07:35:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,27 @@
 Source: grafx2
 Section: graphics
 Priority: optional
-Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
-Build-Depends: debhelper (>= 11), libsdl2-dev, libsdl2-image-dev, libsdl2-ttf-dev, liblua5.3-dev | liblua5.1-0-dev, libpng-dev, pkg-config, libfontconfig1-dev, dh-exec, libtiff-dev
-Standards-Version: 4.2.1
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Uploaders: Gürkan Myczko <gurkan@phys.ethz.ch>
+Build-Depends: debhelper (>= 11),
+               dh-exec,
+               libfontconfig1-dev,
+               liblua5.3-dev | liblua5.1-0-dev,
+               libpng-dev,
+               libsdl2-dev,
+               libsdl2-image-dev,
+               libsdl2-ttf-dev,
+               libtiff-dev,
+               pkg-config
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/multimedia-team/grafx2
+Vcs-Git: https://salsa.debian.org/multimedia-team/grafx2.git
 Homepage: http://pulkomandy.tk/projects/GrafX2
 
 Package: grafx2
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, fonts-tuffy
+Depends: fonts-tuffy, ${misc:Depends}, ${shlibs:Depends}
 Description: ultimate 256-color bitmap paint program
  This is a bitmap paint program that allows you to draw in more than 60 video
  resolutions (from 320x200 to 1024x768, including most of the standard Amiga

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export API=sdl2
export V=1

%:
	dh $@ --sourcedirectory=src

override_dh_auto_install:
	@echo Do not use install target of upstream Makefile

override_dh_auto_test:
	@echo Skip test

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## grafx2 2.8%2Bds

=== debian/changelog ===
grafx2 (2.8+ds-4) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * d/control: update build-depends pkg-config to pkgconf,
    libfontconfig1-dev to libfontconfig-dev.

 -- Alex Myczko <tar@debian.org>  Mon, 22 Jul 2024 12:58:55 +0000

grafx2 (2.8+ds-3) unstable; urgency=medium

  * Apply upstream patch to fix text tool. (Closes: #1009703)
  * Update maintainer address.
  * Bump standards version to 4.6.1.

 -- Gürkan Myczko <tar@debian.org>  Fri, 07 Oct 2022 13:48:48 +0200

grafx2 (2.8+ds-2) unstable; urgency=medium

  * Upload to unstable

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 15 Aug 2021 11:49:53 +0200

grafx2 (2.8+ds-1) experimental; urgency=medium

  * New upstream version. (Closes: #985544)
  * d/copyright: update years, add Upstream-Contact.
  * Bump standards version to 4.5.1.
  * Bump debhelper version to 13, drop d/compat.
  * d/upstream/metadata: added.
  * d/control: added Rules-Requires-Root.
  * d/watch: drop template part.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 25 Mar 2021 10:58:12 +0100
